{*******************************************************}
{                                                       }
{         Copyright (c) FINANCES Ltd                    }
{         2003   ver. 2                                 }
{                                                       }
{         www.finances-ltd.narod.ru                     }
{         finances-ltd@narod.ru                         }
{                                                       }
{                                                       }
{         Thanks to Michal Mutl                         }
{         www.mitec.cz                                  }
{                                                       }
{*******************************************************}

unit zXPPanel;

interface

uses
  Windows, SysUtils, Classes, Controls, ExtCtrls, Graphics, StdCtrls, Messages, ImgList, Forms,
  Dialogs, Menus, zSimpleTimer;

type

{  TTimerClass = class ( TObject )
    protected
      procedure OnTimerProc(sender : TObject);
  end;

  TExPopupList = class(TPopupList)
    protected
      procedure WndProc(var Message: TMessage); override;
  end;}


  TOnDrawLabelText = procedure(Sender: TObject; Canvas: TCanvas; Rect: TRect; Text: string) of object;

  TItemLabel = class(TCustomLabel)
  private
    FMouseInControl: Boolean;
    FImageIndex: Integer;
    //FOldFont: TFont;
    FStatic: Boolean;
    FAlignment: TAlignment;
    FSelected: Boolean;
    FOnDrawText: TOnDrawLabelText;
    FRightText: string;
    FRightTextFont: TFont;
    FDropDownMenu: TPopupMenu;
    FTimer: TzSimpleTimer;
    FAutoPopup: Boolean;
    FArrowRect: TRect;
    xPos: Integer;
    FGlyph: TBitmap;
//    FMenuMaxWidth: Integer;

    procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMVisibleChanged(var Message: TMessage); message CM_VISIBLECHANGED;
    procedure CMDialogChar(var Message: TCMDialogChar); message CM_DIALOGCHAR;
//    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;

    procedure SetStatic(Value: Boolean);
    procedure SetMouseInControl(Value: Boolean);
    procedure SetAlignment(Value: TAlignment);
    procedure SetSelected(Value: Boolean);
    procedure SetRightText(Value: string);
    procedure SetDropDownMenu(Value: TPopupMenu);
    procedure OnTimer(Sender: TObject);
    procedure SetGlyph(Value: TBitmap);
    function GetGlyph: TBitmap;
//    procedure MenuDrawItem(Sender: TObject; ACanvas: TCanvas;
//                           ARect: TRect; Selected: Boolean);
//    procedure MenuMeasureItem(Sender: TObject; ACanvas: TCanvas;
//                              var Width, Height: Integer);
//    procedure MenuChange(Sender: TObject; Source: TMenuItem; Rebuild: Boolean);
  protected
    procedure Paint; override;
    procedure DoDrawText(var Rect: TRect; Flags: Longint); override;
    property MouseInControl: Boolean read FMouseInControl write SetMouseInControl;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destory(AOwner: TComponent);
    procedure DrawCaptionText;
    procedure Popup;

  published
    property ImageIndex: Integer read FImageIndex write FImageIndex Default -1;
    property Static: Boolean read FStatic write SetStatic;
    property Selected: Boolean read FSelected write SetSelected Default False;
    property OnDrawText: TOnDrawLabelText read FOnDrawText write FOnDrawText;
    property RightText: string read FRightText write SetRightText;
    property RightTextFont: TFont read FRightTextFont write FRightTextFont;
    property DropDownMenu: TPopupMenu read FDropDownMenu write SetDropDownMenu;
    property AutoPopup: Boolean read FAutoPopup write FAutoPopup Default false;
    property Glyph: TBitmap read GetGlyph write SetGlyph;

    property Align;
    property Alignment: TAlignment read FAlignment write SetAlignment;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Caption;
    property Color nodefault;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowAccelChar;
    property ShowHint;
    property Layout;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnStartDock;
    property OnStartDrag;
  end;

  {TzXPPanelActionLink = class(TControlActionLink)
  protected
    FClient: TzXPPanel;
    procedure SetChecked(Value: Boolean); override;
  end;}

  TzXPPanel = class(TCustomPanel)
  private
    { Private declarations }
    FFullHeight: Integer;
    FCaptRect: TRect;
    FGradientToColor: TColor;
    FMouseInControl: Boolean;
    FResizeProcess: Boolean;
    FImageList: TCustomImageList;
    FItemBackColor: TColor;
    FGlyph: TBitmap;
    FImageIndex: Integer;
    FBusy: Boolean;
    FFixedHeight: Boolean;
    FSelected: TItemLabel;
    FOnPaint: TNotifyEvent;
    FShowMinimized: Boolean;
    FUpdate: Word;
    // Michal Mutl
    FMinimized: Boolean;
    FOSC: TNotifyEvent;
    FBS: Byte;
    FGradientFromColor: TColor;
    FHFC: TColor;


   procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
//    procedure CMDialogChar(var Message: TCMDialogChar); message CM_DIALOGCHAR;
    procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure SetItemBackColor(Value: TColor);
    procedure SetGradientToColor(Value: TColor);
    procedure SetMouseInControl(Value: Boolean);
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure SetGlyph(Value: TBitmap);
    function GetGlyph: TBitmap;
    procedure SetImageIndex(Value: Integer);
    function GetCount: Integer;
    procedure SetSelected(Value: TItemLabel);
    // Michal Mutl
    procedure SetMinimized(const Value: Boolean);
    procedure SetBS(const Value: Byte);
    procedure SetGradientFromColor(const Value: TColor);
  protected
    procedure Paint; override;
    procedure Loaded;  override;
    procedure DrawCaptionText;
    property MouseInControl: Boolean read FMouseInControl write SetMouseInControl;
  public
    Items: array of TItemLabel;
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    function Add(aCaption: string; aImageIndex: Integer = -1): TItemLabel;
    function GetIndex(aItem: TItemLabel): Integer;
    function FindItem(aCaption: string): TItemLabel;
    procedure RedrawItems(FromItem: TItemLabel = nil);
    procedure Delete(aIndex: Integer);
    procedure BeginUpdate;
    procedure EndUpdate;

    procedure Expand;
    procedure Collapse;
    procedure DrawSeparator(yPos: Integer);
    property Busy: Boolean read FBusy write FBusy;
    property Canvas;
  published
    property Count: Integer read GetCount;
    property ImageList: TCustomImageList read FImageList write FImageList;
    property ItemBackColor: TColor read FItemBackColor write SetItemBackColor default $00F7DFD6;
    property GradientToColor: TColor read FGradientToColor write SetGradientToColor default $00F7D3C6;
    property Glyph: TBitmap read GetGlyph write SetGlyph;
    property ImageIndex: Integer read FImageIndex write SetImageIndex;
    property FixedHeight: Boolean read FFixedHeight write FFixedHeight Default False;
    property Selected: TItemLabel read FSelected write SetSelected Default nil;
    property ShowMinimized: Boolean read FShowMinimized write FShowMinimized Default False;
    // Michal Mutl
    property Minimized: Boolean read FMinimized Write SetMinimized Default False;
    property BorderSize: Byte read FBS Write SetBS;
    property OnSizeChange: TNotifyEvent read FOSC Write FOSC;
    property GradientFromColor: TColor read FGradientFromColor write SetGradientFromColor default clWhite;
    property HighlightFontColor: TColor read FHFC Write FHFC;

    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;

    property Align;
    property Anchors;
    property BiDiMode;
    property Caption;
    property Color default $00F7DFD6;
    property Constraints;
    property UseDockManager default True;
    property Font;
    property Hint;
    property DockSite;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property ParentShowHint;
    property ShowHint;
    property Visible;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetSiteInfo;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
  end;

{var FTimer : TSimpleTimer;
    FTimerClass : TTimerClass;
    FOpeningNow : boolean;
    FPopUpMenu : TPopUpMenu;}

procedure Register;

implementation

///////////////////////  TexPopuMenu  //////////////////////////

{ TTImerClass }
{procedure TTimerClass.OnTimerProc(sender : TObject);
var
  W: HWND;
  WRect : Windows.TREct;
  Point : Tpoint;
begin
  W := GetCapture;
  if (W <> 0) then
  begin
  GetMenuItemRect(0, FPopUpMenu.Handle, 0,WRect);
    if FOpeningNow then
      begin
        GetMenuItemRect(0,FPopUpMenu.Handle, 0 ,WRect);
        if WRect.Left  <> 0 then
              begin
               SetCursorPos(WRect.Left + 25, WRect.Top + 10);
               FOpeningNow := false;
              end
      end else // FOpeningNow
  if (Integer(MenuItemFromPoint(0,FPopUpMenu.Handle, mouse.cursorpos)) = -1)
  then  SendMessage(W, WM_CANCELMODE, 0, 0);
  end;
end;}



{ TExPopupList }

{procedure TExPopupList.WndProc(var Message: TMessage);
begin
  //if ExtendedPopUp then
    case message.Msg of
      WM_ENTERMENULOOP :
            begin
              FTimer.Enabled := true;
              FOpeningNow := true;
             end;
      WM_EXITMENULOOP :  FTImer.Enabled := false;
    end;
  inherited;
end;}

{procedure SetPopUpMenu(PopUpMenu : TPopUpMenu);
begin
 if PopUpMenu <> nil then
    begin
    FPopUpMenu := PopUpMenu;
    ExtendedPopUp := true;
    end
       else begin
            ExtendedPopUp :=false;
            end;
end;}

///////////////////////  TItemLabel  //////////////////////////

constructor TItemLabel.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FSelected := False;
  FMouseInControl := False;
  Anchors := Anchors + [akRight];
  AutoSize := False;
  FImageIndex := -1;
  Transparent := True;
  FRightText := '';
  //if AOwner is TzXPPanel then
  //  Color := (AOwner as TzXPPanel).ItemBackColor;
  Color := $00F7DFD6;
  Layout := tlCenter;
  FRightTextFont := TFont.Create;
  FTimer := TzSimpleTimer.Create(1000, OnTimer);
  FTimer.AutoDisable := True;
  FAutoPopup := False;
  FDropDownMenu := nil;
  Cursor := crHandPoint;
end;

destructor TItemLabel.Destory(AOwner: TComponent);
begin
  if Assigned(FGlyph) then FGlyph.Free;
  if Assigned(FRightTextFont) then FRightTextFont.Free;
  if (Parent is TzXPPanel) and ((Parent as TzXPPanel).Selected = Self) then
    (Parent as TzXPPanel).Selected := nil;
  FTimer.Free;
  inherited Destroy;
end;

procedure TItemLabel.Paint;
var
  Rect: TRect;
  BM: TBitmap;
  w, x, y, NewColor: Integer;
  PixelColor: TColor;
begin
  with Canvas do begin
    {if not (Parent is TzXPPanel) then begin
      inherited;
      Exit;
    end;}
    Rect := ClientRect;
    if (Parent is TzXPPanel) then
      Brush.Color := (Parent as TzXPPanel).ItemBackColor
    else Brush.Color := Self.Color;
    FillRect(Rect);

    DrawCaptionText;

    if Assigned(FGlyph) or ((Parent is TzXPPanel) and
       Assigned((Parent as TzXPPanel).FImageList) and (FImageIndex <> -1) and
       (FImageIndex in [0..Pred((Parent as TzXPPanel).FImageList.Count)])) then begin

      BM := TBitmap.Create;
      BM.Transparent := True;
      if Assigned(FGlyph) then
        BM.Assign(FGlyph)
      else (Parent as TzXPPanel).FImageList.GetBitmap(FImageIndex, BM);

      try
        w := BM.Width;
        if not Enabled then
          for x := 0 to w - 1 do
            for y := 0 to w - 1 do begin
              PixelColor := ColorToRGB(BM.Canvas.Pixels[x, y]);
              NewColor := Round((((PixelColor shr 16) + ((PixelColor shr 8) and $00FF) +
                                 (PixelColor and $0000FF)) div 3)) div 2 + 96;
              BM.Canvas.Pixels[x, y] := RGB(NewColor, NewColor, NewColor);
            end;

        case Layout of
          tlTop: y := 1;
          tlCenter: y := ClientRect.Bottom div 2 - BM.Height div 2;
          else y := Height - BM.Height - 1;
        end;

        case Alignment of
          taCenter: x := ClientRect.Right div 2 - TextWidth(Caption) div 2 - BM.Width - 5;
          taRightJustify: x := ClientRect.Right - TextWidth(Caption) - BM.Width - 5;
          else x := 1;
        end;
        Draw(x, y, BM);
      finally
        BM.Free;
      end;
//      if not FStatic then
//        rect.Left := rect.left + (Parent as TzXPPanel).FImageList.Width + 10;
    end;

  end;
end;

procedure TItemLabel.CMMouseEnter(var Message: TMessage);
begin
  if (csDesigning in ComponentState) or not Enabled then Exit;
  MouseInControl := True;
  if FAutoPopup then FTimer.Enabled := True;
  inherited;
end;

procedure TItemLabel.CMMouseLeave(var Message: TMessage);
begin
  if (csDesigning in ComponentState) or not Enabled then Exit;
  MouseInControl := False;
  FTimer.Enabled := False;
//  if Assigned(FDropDownMenu) and not FTimer.Enabled then
//    SendMessage(FDropDownMenu.Handle, WM_KILLFOCUS, 0, 0);
  inherited;
end;

procedure TItemLabel.CMVisibleChanged(var Message: TMessage);
begin
  if (Parent is TzXPPanel) and not (Parent as TzXPPanel).Busy then
    (Parent as TzXPPanel).RedrawItems(Self);
end;

procedure TItemLabel.SetStatic(Value: Boolean);
begin
  if FStatic <> Value then begin
    FStatic := Value;
    if not Value then
      Cursor := crHandPoint
    else Cursor := crDefault;
  end;
end;

procedure TItemLabel.SetMouseInControl(Value: Boolean);
begin
  if FMouseInControl = Value then Exit;
  FMouseInControl := Value;
  DrawCaptionText;
end;

procedure TItemLabel.DrawCaptionText;
const
  Alignments: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);
  WordWraps: array[Boolean] of Word = (0, DT_WORDBREAK);
var
  Rect, CalcRect: TRect;
  DrawStyle: Longint;
  OldColor: TColor;
begin
  with Canvas do begin
    Rect := ClientRect;
    case Alignment of
      taCenter: Rect.Left := Rect.Left + (Rect.Right - TextWidth(Caption)) div 2;
      taRightJustify:
        Rect.Left := Rect.Left + (Rect.Right - TextWidth(Caption) - 1);
    end;

    Font.Assign(Self.Font);
    if not Enabled then
      Font.Color := clGray;
    if not FStatic and Enabled then begin
      if FMouseInControl then begin
        if FSelected then
          Font.Color := RGB(190, 126, 126)
        else begin
          if not Assigned(FDropDownMenu) or FAutoPopup or (xPos < ClientRect.Right - 12) then
            Font.Color := RGB(66, 142, 255)
          else Font.Color := Self.Font.Color;
        end;
        if Assigned(OnClick) then
          Font.Style := Font.Style + [fsUnderLine];
      end
      else begin
        if FSelected then
          Font.Color := $000000D2 //RGB(173, 90, 90)
        else Font.Color := RGB(33, 93, 198);
        Font.Style := Font.Style - [fsUnderLine];
      end;
    end;

    if Assigned(FGlyph) then begin
      if Alignment = taLeftJustify then begin
        Rect.Left := Rect.Left + FGlyph.Width + 10;
        Rect.Right := Rect.Right + FGlyph.Width + 10;
      end;
    end
    else if (Parent is TzXPPanel) and Assigned((Parent as TzXPPanel).FImageList) then
//       and (not FStatic or (FImageIndex <> -1)) then
    begin
      if Alignment = taLeftJustify then begin
        Rect.Left := Rect.Left + (Parent as TzXPPanel).FImageList.Width + 10;
        Rect.Right := Rect.Right + (Parent as TzXPPanel).FImageList.Width + 10;
      end;
    {case Alignment of
      taCenter: Rect.Left := Rect.left + (Rect.Right div 2 - TextWidth(Caption) div 2);
      taRightJustify: Rect.Left := Rect.Right - TextWidth(Caption);
      else Rect.Left := Rect.Left + (Parent as TzXPPanel).FImageList.Width + 10;
    end;}

      {if ClientRect.Right < TextWidth(Caption) + (Parent as TzXPPanel).FImageList.Width + 10 then begin
        AutoSize := False;
        Self.Width := Self.Width + (Parent as TzXPPanel).FImageList.Width + 10;
        if ClientRect.Left + ClientRect.Right > (Parent as TzXPPanel).Width - 25 then
          Self.Width := Self.Width - ((Parent as TzXPPanel).Width - 25 - ClientRect.Left);
      end;}
    end;

    Brush.Color := Self.Color;
    Brush.Style := bsSolid;
    Rect.Top := Rect.Top + 1;
    Rect.Bottom := Rect.Bottom - 2;
    Rect.Right := Rect.Right -1;
    //offsetRect(Rect, -1, -1);
    FillRect(Rect);

    DrawStyle := DT_EXPANDTABS or WordWraps[WordWrap] or DT_LEFT;
    Brush.Style := bsClear;
    { Calculate vertical layout }
    if Layout <> tlTop then
    begin
      CalcRect := Rect;
      DoDrawText(CalcRect, DrawStyle or DT_CALCRECT);
      if Layout = tlBottom then OffsetRect(Rect, 0, Height - CalcRect.Bottom)
      else OffsetRect(Rect, 0, (Height - CalcRect.Bottom) div 2);
    end;
    DoDrawText(Rect, DrawStyle);
    if FRightText <> '' then begin
      OldColor := Font.Color;
      Font.Color := FRightTextFont.Color;
      CalcRect.Left := ClientRect.Right - TextWidth(FRightText) - 1;
       if Assigned(FDropDownMenu) then begin
         CalcRect.Left := CalcRect.Left - 14;
         Rect.Right := Rect.Right - 14;
       end;

      TextOut(Rect.Right - TextWidth(FRightText) - 1, Rect.Top, FRightText);
      Font.Color := OldColor;
    end;
    if Assigned(FOnDrawText) then
      FOnDrawText(Self, Canvas, Rect, Caption);
    {if FSelected then
      Pen.Color := Font.Color
    else Pen.Color := Color;
    Polyline([Point(ClientRect.Left, ClientRect.Top),
                    Point(ClientRect.Right - 1, ClientRect.Top),
                    Point(ClientRect.Right - 1, ClientRect.Bottom - 1),
                    Point(ClientRect.Left, ClientRect.Bottom - 1),
                    Point(ClientRect.Left, ClientRect.Top)]);}

    if Assigned(FDropDownMenu) and (FDropDownMenu.Items.Count > 0) then with FArrowRect do begin
      Left := ClientRect.Right - 12;
      Right := ClientRect.Right - 1;
      Top := ClientRect.Top + ((ClientRect.Bottom - ClientRect.Top) div 2 - 5);
      Bottom := Top + 12;
      if Enabled then begin
        if (xPos >= Left) or (FMouseInControl and FAutoPopup) then
          Pen.Color := RGB(66, 142, 255)
        else Pen.Color := Self.Font.Color;
      end
      else Pen.Color := clSilver;

      if not FAutoPopup then
        Polygon([Point(Left, Top),
                 Point(Right, Top),
                 Point(Right, Bottom),
                 Point(Left, Bottom),
                 Point(Left, Top)]);
      Brush.Color := Pen.Color;
      Polygon([Point(Right - 6, Top + 4),
               Point(Right - 4, Top + 6),
               Point(Right - 6, Top + 8),
               Point(Right - 6, Top + 4)]);
    end;
  end;
end;

procedure TItemLabel.DoDrawText(var Rect: TRect; Flags: Longint);
var
  Text: string;
begin
  Text := GetLabelText;
  if (Flags and DT_CALCRECT <> 0) and ((Text = '') or ShowAccelChar and
    (Text[1] = '&') and (Text[2] = #0)) then Text := Text + ' ';
  if not ShowAccelChar then Flags := Flags or DT_NOPREFIX;
  Flags := DrawTextBiDiModeFlags(Flags);
  if not Enabled then
  begin
    OffsetRect(Rect, 1, 1);
    Canvas.Font.Color := clBtnHighlight;
    DrawText(Canvas.Handle, PChar(Text), Length(Text), Rect, Flags);
    OffsetRect(Rect, -1, -1);
    Canvas.Font.Color := clBtnShadow;
    DrawText(Canvas.Handle, PChar(Text), Length(Text), Rect, Flags);
  end
  else
    DrawText(Canvas.Handle, PChar(Text), Length(Text), Rect, Flags);
end;

procedure TItemLabel.SetAlignment(Value: TAlignment);
begin
  inherited;
  if FAlignment <> Value then begin
    FAlignment := Value;
    DrawCaptionText;
  end;
end;

procedure TItemLabel.CMDialogChar(var Message: TCMDialogChar);

function GetHotkey(const Text: string): string;
var
  I, L: Integer;
begin
  Result := '';
  I := 1;
  L := Length(Text);
  while I <= L do
  begin
    if Text[I] in LeadBytes then
      Inc(I)
    else if (Text[I] = '&') and
            (L - I >= 1) then
    begin
      Inc(I);
      if Text[I] <> '&' then
        Result := Text[I]; // keep going there may be another one
    end;
    Inc(I);
  end;
end;

  function IsAccel(VK: Word; const Str: string): Boolean;
  begin
    Result := CompareText(Char(VK), GetHotKey(Str)) = 0;
  end;

begin
  if Assigned(OnClick) and Enabled and ShowAccelChar and
    IsAccel(Message.CharCode, Caption) then
      begin
        OnClick(Self);
        Message.Result := 1;
      end;
end;

procedure TItemLabel.SetSelected(Value: Boolean);
begin
  if (csDestroying in ComponentState) then Exit;
  if FSelected <> Value then begin
    FSelected := Value;
    DrawCaptionText;
    if not Value then begin
      if (Parent is TzXPPanel) and ((Parent as TzXPPanel).Selected = Self) then
        (Parent as TzXPPanel).Selected := nil;
      end
    else (Parent as TzXPPanel).Selected := Self;
  end;
end;

procedure TItemLabel.SetRightText(Value: string);
begin
  if FRightText = Value then Exit;
  FRightText := Value;
  DrawCaptionText;
end;

procedure TItemLabel.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FDropDownMenu) then
    FDropDownMenu := nil;
end;

procedure TItemLabel.SetDropDownMenu(Value: TPopupMenu);
begin
  FDropDownMenu := Value;
  if Value <> nil then begin
    Value.FreeNotification(Self);
    //Value.OwnerDraw := True;
    //Value.OnChange := MenuChange;
  end;
end;

procedure TItemLabel.OnTimer(Sender: TObject);
var MousePos: TPoint;
begin
  if Assigned(FDropDownMenu) then begin
    MousePos.X := ClientOrigin.X + Width;
    MousePos.Y := ClientOrigin.Y;
    //MousePos := (Owner as TForm).ClientToScreen(MousePos);
    //SetCursorPos(MousePos.X + 30, MousePos.Y + 8);
    //FPopUpMenu := FDropDownMenu;
    FDropDownMenu.Popup(MousePos.X, MousePos.Y);
  end;
end;

procedure TItemLabel.Popup;
begin
  OnTimer(nil);
end;

procedure TItemLabel.WMMouseMove(var Message: TWMMouseMove);
begin
  inherited;
  xPos := Message.XPos;
  if Assigned(FDropDownMenu) and not FAutopopup and
     (((FArrowRect.Left > xPos) and (Canvas.Font.Color = Font.Color)) or
     ((FArrowRect.Left <= xPos) and (Canvas.Font.Color <> Font.Color))) then
    DrawCaptionText;
end;

procedure TItemLabel.WMLButtonUp(var Message: TWMLButtonUp);
begin
  FTimer.Enabled := False;
  if not Assigned(FDropDownMenu) or FAutoPopup or (xPos < ClientRect.Right - 12) then
    inherited
  else OnTimer(nil);
end;

procedure TItemLabel.SetGlyph(Value: TBitmap);
begin
  if FGlyph = nil then begin
    FGlyph := TBitmap.Create;
    FGlyph.Transparent := True;
  end;
  FGlyph.Assign(Value);
  Invalidate;
end;

function TItemLabel.GetGlyph: TBitmap;
begin
  if FGlyph = nil then begin
    FGlyph := TBitmap.Create;
    FGlyph.Transparent := True;
  end;
  Result := FGlyph;
end;

{procedure TItemLabel.MenuDrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
  with ACanvas do begin
    Brush.Color := $00F7DFD6;
    if Selected then begin
      Font.Color := RGB(66, 142, 255);
      Font.Style := [fsUnderline];
    end
    else Font.Color := Self.Font.Color;

    FillRect(ARect);

    if (Parent is TzXPPanel) and Assigned((Parent as TzXPPanel).FImageList) then begin
       if (FImageIndex <> -1) and
          (FImageIndex in [0..Pred((Parent as TzXPPanel).FImageList.Count)]) then
         (Parent as TzXPPanel).FImageList.Draw(ACanvas, 2, ARect.Top + 2, ImageIndex);
       ARect.Left := (Parent as TzXPPanel).FImageList.Width + 6;
    end
    else ARect.Left := 2;

    DrawText(Handle, PChar(Caption), -1, ARect, DT_LEFT or DT_VCENTER or DT_SINGLELINE or DT_NOCLIP);
  end;
end;

procedure TItemLabel.MenuMeasureItem(Sender: TObject; ACanvas: TCanvas;
  var Width, Height: Integer);
begin
  Width := FMenuMaxWidth;
end;}

{procedure TItemLabel.MenuChange(Sender: TObject; Source: TMenuItem;
  Rebuild: Boolean);
var i, w: Integer;
begin
    Canvas.Font.Name := 'MS Sans Serif';
    Canvas.Font.Size := 8;
    FMenuMaxWidth := 0;
    for i := 0 to Pred(FDropDownMenu.Items.Count) do begin
      FDropDownMenu.Items.OnDrawItem := MenuDrawItem;
      FDropDownMenu.Items.OnMeasureItem := MenuMeasureItem;
      w := Canvas.TextWidth(FDropDownMenu.Items[i].Caption);
      if w > FMenuMaxWidth then FMenuMaxWidth := w;
    end;
    Inc(FMenuMaxWidth, 10);
end;}

////////////////////////////////////////////////////////  TzXPPanel

constructor TzXPPanel.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  // Michal Mutl
  FOSC:=nil;
  FBS:=10;

  FImageIndex := -1;
  FullRepaint := False;
  FResizeProcess := False;
  FGradientToColor := RGB(198, 211, 247);
  FGradientFromColor := clWhite;
  FItemBackColor := RGB(214, 223, 247);
  FBusy := False;
  FFixedHeight := False;
  FSelected := nil;

  BevelOuter := bvNone;
  Color := RGB(101, 120, 215);
  Font.Color := RGB(0, 60, 165);
  Font.Style := [fsBold];
  Caption := Name;
  FHFC:= RGB(66, 142, 255);

  with FCaptRect do begin
    Left := 12;
    Top := 12;
    Bottom := 25;
  end;

end;

destructor TzXPPanel.Destroy;
var i: Integer;
begin
  if Assigned(FGlyph) then FGlyph.Free;
  for i := High(Items) downto 0 do Items[i].Free;
  inherited Destroy;
end;

procedure TzXPPanel.Paint;

  procedure FillWithGradient;
  var
    TargetRect : TRect;
    i         : Integer;
    clrFrom, clrTo : TColor;
    RGBFromR,RGBFromG,RGBFromB : Byte;
    RGBDiffR,RGBDiffG,RGBDiffB : integer;

  begin
// Michal Mutl
   if not Enabled then
     clrFrom := clWhite
   else
     clrFrom := FGradientFromColor;
   if not Enabled then
     clrTo := cl3DLight
   else clrTo := FGradientToColor;

   RGBFromR := GetRValue(ColorToRGB(ClrFrom));
   RGBFromG := GetGValue(ColorToRGB(ClrFrom));
   RGBFromB := GetBValue(ColorToRGB(ClrFrom));
   RGBDiffR := GetRValue(ColorToRGB(ClrTo)) - RGBFromR;
   RGBDiffG := GetGValue(ColorToRGB(ClrTo)) - RGBFromG;
   RGBDiffB := GetBValue(ColorToRGB(ClrTo)) - RGBFromB;

   Canvas.Pen.Style := psSolid;
   Canvas.Pen.Mode := pmCopy;
     for i := 0 to 255 do
     begin
         with FCaptRect do begin
           //TargetRect := Rect(MulDiv (i + Left - 1, Right - Left, 256), Top,
           //                   MulDiv (i + Left, Right - Left, 256), Top + Bottom);
           TargetRect := Rect(MulDiv (i, Right, 256),0,
                              MulDiv (i+1, Right, 256), Bottom);
           TargetRect.Left := TargetRect.Left + Left;
           TargetRect.Right := TargetRect.Right + Left;
           TargetRect.Top := TargetRect.Top + Top;
           TargetRect.Bottom := TargetRect.Bottom + Top;
         end;
         Canvas.Brush.Color := RGB (RGBFromR + MulDiv(i,RGBDiffR, 255),
                                    RGBFromG + MulDiv(i,RGBDiffG, 255),
                                    RGBFromB + MulDiv(i,RGBDiffB, 255));


         Canvas.FillRect (TargetRect);
     end;
  end;

var BM: TBitmap;
    x, y, w, h, NewColor, t: Integer;
    PixelColor: TColor;
begin
  try
    FCaptRect.Right := FCaptRect.Left + (Width-2*FBS); // Michal Mutl
    FillWithGradient;
    Canvas.Brush.Color := Color;
    Canvas.Pen.Color := Color;
    with Canvas.ClipRect do
      Canvas.Polygon([Point(0, 0),
                      Point(0, Bottom),
                      Point(FCaptRect.Left - 1, Bottom),
                      Point(FCaptRect.Left - 1, FCaptRect.Top - 1),
                      Point(FCaptRect.Right, FCaptRect.Top - 1),
                      Point(FCaptRect.Right, Bottom),
                      Point(Right, Bottom),
                      Point(Right, 0),
                      Point(0, 0)]);

    with FCaptRect, Canvas do begin
      Pixels[Left, Top] := RGB(101, 120, 215);
      Pixels[Left + 1, Top] := RGB(101, 120, 215);
      Pixels[Left, Top + 1] := RGB(101, 120, 215);
      Pixels[Right - 1, Top] := RGB(101, 120, 215);
      Pixels[Right - 2, Top] := RGB(101, 120, 215);
      Pixels[Right - 1, Top + 1] := RGB(101, 120, 215);

        //if Height > Top + Bottom then begin
        if (Height = FFullHeight) or (csDesigning in ComponentState) then begin
          if FResizeProcess and (Height <> FFullHeight) then
            Pen.Color := FItemBackColor
          else Pen.Color := clWhite;
          Polyline([Point(Left, Top + Bottom),
                    Point(Left, ClientRect.Bottom - 1),
                    Point(Right - 1, ClientRect.Bottom - 1),
                    Point(Right - 1, Top + Bottom - 1)]);
          Brush.Color := FItemBackColor;
          FillRect(Rect(Left + 1,
                      Top + Bottom,
                      Right - 1,
                      ClientRect.Bottom - 1));
        end;

      if Assigned(FGlyph) then begin
        t := (Bottom div 2 - FGlyph.Height div 2) + Top;
        if t = Top then Inc(t)
        else if t < Top then
          t := Top + Bottom - FGlyph.Height;
        if not Enabled then begin
          BM := TBitmap.Create;
          BM.Transparent := True;
          try
            BM.Assign(FGlyph);
            w := BM.Width;
            h := BM.Height;
            if not Enabled then
              for x := 0 to w - 1 do
                for y := 0 to h - 1 do begin
                  PixelColor := ColorToRGB(BM.Canvas.Pixels[x, y]);
                  NewColor := Round((((PixelColor shr 16) + ((PixelColor shr 8) and $00FF) +
                                   (PixelColor and $0000FF)) div 3)) div 2 + 96;
                  BM.Canvas.Pixels[x, y] := RGB(NewColor, NewColor, NewColor);
                end;
            Draw(Left + 5, t, BM);
          finally
            BM.Free;
          end;
        end
        else Draw(Left + 5, t, FGlyph);
      end
      else if (FimageIndex <> -1) and Assigned(FImageList)
             and (FimageIndex in [0..Pred(FImageList.Count)]) then begin
          BM := TBitmap.Create;
          BM.Transparent := True;
          try
            FImageList.GetBitmap(FImageIndex, BM);
            w := BM.Width;
            if not Enabled then
              for x := 0 to w - 1 do
                for y := 0 to w - 1 do begin
                  PixelColor := ColorToRGB(BM.Canvas.Pixels[x, y]);
                  NewColor := Round((((PixelColor shr 16) + ((PixelColor shr 8) and $00FF) +
                                 (PixelColor and $0000FF)) div 3)) div 2 + 96;
                  BM.Canvas.Pixels[x, y] := RGB(NewColor, NewColor, NewColor);
                end;

            t := (Bottom div 2 - BM.Height div 2) + Top;
            if t = Top then Inc(t)
            else if t < Top then
              t := Top + Bottom - BM.Height;
            Draw(Left + 5, t, BM);
          finally
            BM.Free;
          end;
      end;
      DrawCaptionText;

    end;
  finally
    if Assigned(FOnPaint) then FOnPaint(Self);
  end;
end;

procedure TzXPPanel.Loaded;
begin
  if Enabled then begin
    FFullHeight := Height;
    if (not (csDesigning in ComponentState)) and FMinimized then  // Michal Mutl
      Collapse;
  end;
  Parent.Realign;
end;

procedure TzXPPanel.WMMouseMove(var Message: TWMMouseMove);
begin
  inherited;
    with FCaptRect do
     MouseInControl := (Message.XPos >= Left) and
                        (Message.XPos <= Right) and
                        (Message.YPos >= Top) and
                        (Message.YPos <= Top + Bottom);
end;


procedure TzXPPanel.WMLButtonUp(var Message: TWMLButtonUp);
//var i: Integer;
begin
  inherited;
  if MouseInControl then begin
    if Height < FFullHeight then   // Michal Mutl
      Expand
    else
      Collapse  
    {if Height < FFullHeight then
      Height := FFullHeight
    else Height := FCaptRect.Top + FCaptRect.Bottom + 1;}
  end;
  Parent.Realign;
  //Invalidate;
{  if Height < FFullHeight then begin
    FResizeProcess := True;
    while Height < FFullHeight do begin
       Height := Height + 5;
       Update;
       Sleep(5);
    end;
  end
  else begin
    h := FCaptRect.Top + FCaptRect.Bottom;
    FFullHeight := Height;
    while Height > h do begin
       Height := Height - 5;
       Update;
       Sleep(5);
    end;
  end;
  FResizeProcess := False;
  Parent.Realign;}
end;

function TzXPPanel.Add(aCaption: string; aImageIndex: Integer = -1): TItemLabel;
var t: Integer;
begin
  SetLength(Items, High(Items) + 2);
  Items[High(Items)] := TItemLabel.Create(Self);
  Result := Items[High(Items)];
  FBusy := True;
  with Items[High(Items)] do begin
    Parent := Self;
    ParentFont := False;
    Cursor := crHandPoint;
    AutoSize := False;
    Left := 24;
    if High(Items) = 0 then
      Top := FCaptRect.Top + FCaptRect.Bottom + 5
    else Top := Items[High(Items) - 1].Top + Items[High(Items) - 1].Height;
    WordWrap := True;
    Width := Self.Width - 48;
    t := Canvas.TextHeight('A');
    if Assigned(FImageList) and (FImageList.Height + 2 > t) then
      t :=  FImageList.Height + 2;
    Height := t + 6;
    Color := RGB(214, 223, 247);
    ImageIndex := aImageIndex;
    Font.Color := RGB(33, 93, 198);
    Caption := aCaption;
  end;
  FBusy := False;
  if FUpdate = 0 then
    RedrawItems(Items[High(Items)]);
end;

function TzXPPanel.GetIndex(aItem: TItemLabel): Integer;
var i: Integer;
begin
  Result := -1;
  for i := 0 to High(Items) do
    if Items[i] = aItem then begin
      Result := i;
      Exit;
    end;
end;

function TzXPPanel.FindItem(aCaption: string): TItemLabel;
var i: Integer;
begin
  Result := nil;
  for i := 0 to High(Items) do
    if Items[i].Caption = aCaption then begin
      Result := Items[i];
      Exit;
    end;
end;

procedure TzXPPanel.RedrawItems(FromItem: TItemLabel = nil);
var i, t: Integer;
begin
  if FFixedHeight then Exit;
  FBusy := True;
  try
    if Assigned(FromItem) then begin
      i := GetIndex(FromItem);
//      if i = 0 then Exit;
    end
    //else if High(Items) > 0 then
    //  i := 1
    else i := 0;

    //t := FCaptRect.Top + FCaptRect.Bottom + 1;
    for i := i to High(Items) do begin
      if i = 0 then Continue;
      t := Items[i - 1].Top;
      if Items[i - 1].Visible then
        t := t + Items[i - 1].Height;
      Items[i].Top := t;
    end;
  finally
    if High(Items) > -1 then begin
      FFullHeight :=  Items[Count - 1].Top + Items[Count - 1].Height + 2;
      Height := FFullHeight;
    end
    else with FCaptRect do
      Height := Top + Bottom + 1;
    FBusy := False;
  end;
end;

procedure TzXPPanel.SetItemBackColor(Value: TColor);
begin
  if FItemBackColor <> Value then begin
    FItemBackColor := Value;
    Repaint;
  end;
end;

procedure TzXPPanel.SetGradientToColor(Value: TColor);
begin
  if FGradientToColor <> Value then begin
    FGradientToColor := Value;
    Repaint;
  end;
end;

procedure TzXPPanel.SetMouseInControl(Value: Boolean);
begin
  if FMouseInControl = Value then Exit;
  FMouseInControl := Value;
  DrawCaptionText;
end;

procedure TzXPPanel.DrawCaptionText;
var l: Integer;
    Rect: TRect;
begin
    with FCaptRect, Canvas do begin
      Font.Assign(Self.Font);

      if FmouseInControl then begin
        Pen.Color := clWhite;
        Font.Color := FHFC; //RGB(66, 142, 255);  // Michal Mutl
        Cursor := crHandPoint;
        Brush.Color := Pixels[Width div 2, FCaptRect.Top + 1];
        //Brush.Color := clWhite;
      end
      else if not Enabled then begin
        Font.Color := clGray;
        Pen.Color := clGray;
        Brush.Color := cl3DLight;
      end
      else begin
        Pen.Color := clWhite;
        Cursor := crDefault;
        Brush.Color := FGradientToColor;
      end;
      RoundRect(Right - 17, Top + 5, Right - 2, Top + 20, 4, 4);

      if Enabled then begin
        Pen.Color := RGB(124, 159, 211);
        MoveTo(Right - 15, Top + 20);
        LineTo(Right - 3, Top + 20);
        MoveTo(Right - 2, Top + 7);
        LineTo(Right - 2, Top + 19);
        Pixels[Right - 3, Top + 19] := Pen.Color;
      end;

      if Enabled then
        Pen.Color := RGB(184, 203, 246)
      else Pen.Color := clSilver;
      MoveTo(Right - 16, Top + 7);
      LineTo(Right - 16, Top + 18);
      MoveTo(Right - 16, Top + 6);
      LineTo(Right - 3, Top + 6);
      MoveTo(Right - 4, Top + 6);
      LineTo(Right - 4, Top + 18);
      MoveTo(Right - 16, Top + 18);
      LineTo(Right - 3, Top + 18);

      if Enabled then
        Pen.Color := RGB(124, 159, 211)
      else Pen.Color := clGray;
      // Draw caption arrow
      if (Height = FFullHeight) or FResizeProcess then begin
        Polyline([Point(Right - 13, Top + 11),
                  Point(Right - 10, Top + 8),
                  Point(Right - 6, Top + 12)]);
        Polyline([Point(Right - 12, Top + 11),
                  Point(Right - 10, Top + 9),
                  Point(Right - 7, Top + 12)]);
        Polyline([Point(Right - 13, Top + 15),
                  Point(Right - 10, Top + 12),
                  Point(Right - 6, Top + 16)]);
        Polyline([Point(Right - 12, Top + 15),
                  Point(Right - 10, Top + 13),
                  Point(Right - 7, Top + 16)]);

      end
      else begin
        Polyline([Point(Right - 13, Top + 9),
                  Point(Right - 10, Top + 12),
                  Point(Right - 6, Top + 8)]);
        Polyline([Point(Right - 12, Top + 9),
                  Point(Right - 10, Top + 11),
                  Point(Right - 7, Top + 8)]);
        Polyline([Point(Right - 13, Top + 13),
                  Point(Right - 10, Top + 16),
                  Point(Right - 6, Top + 12)]);
        Polyline([Point(Right - 12, Top + 13),
                  Point(Right - 10, Top + 15),
                  Point(Right - 7, Top + 12)]);
      end;

      // Draw caption text
      Brush.Style := bsClear;
      if Assigned(FGlyph) then
        l := Left + FGlyph.Width + 10
      else if (FimageIndex <> -1) and Assigned(FImageList)
             and (FimageIndex in [0..Pred(FImageList.Count)]) then
         l := Left + FImageList.Width + 10
      else l := Left + 10;
      //TextOut(l, (Bottom div 2 - TextHeight('A') div 2) + Top, Caption);

      Rect.Left := l;
      Rect.Top := Bottom div 2 - TextHeight('A') div 2 + Top;
      Rect.Bottom := Rect.Top + TextHeight('A');
      Rect.Right := Rect.Left + TextWidth(Caption);
      DrawText(Handle, PChar(Caption), Length(Caption), Rect, DT_EXPANDTABS or DT_LEFT);
    end;
end;

procedure TzXPPanel.CMMouseLeave(var Message: TMessage);
begin
  MouseInControl := False;
end;

procedure TzXPPanel.Delete(aIndex: Integer);
var i: Integer;
begin
  if not (aIndex in [0..High(Items)]) then Exit;

  Items[aIndex].Free;
  for i := aIndex + 1 to High(Items) do
    Items[i - 1] := Items[i];
  SetLength(Items, High(Items));
  if FUpdate > 0 then Exit;
  if (aIndex - 1 in [0..High(Items)]) then
    RedrawItems(Items[aIndex - 1])
  else RedrawItems;
end;

procedure TzXPPanel.SetGlyph(Value: TBitmap);
begin
  if FGlyph = nil then begin
    FGlyph := TBitmap.Create;
    FGlyph.Transparent := True;
  end;
  FGlyph.Assign(Value);
  Invalidate;
end;

function TzXPPanel.GetGlyph: TBitmap;
begin
  if FGlyph = nil then begin
    FGlyph := TBitmap.Create;
    FGlyph.Transparent := True;
  end;
  Result := FGlyph;
end;

procedure TzXPPanel.CMEnabledChanged(var Message: TMessage);
begin
  inherited;
  if not Enabled and not(csDesigning in ComponentState) then begin
    if Height > FCaptRect.Top + FCaptRect.Bottom + 1 then
      FFullHeight := Height;
    Height := FCaptRect.Top + FCaptRect.Bottom + 1;
  end;
  Parent.Realign;
end;

procedure TzXPPanel.SetImageIndex(Value: Integer);
begin
  if FImageIndex <> Value then begin
    FImageIndex := Value;
    Invalidate;
  end;
end;

function TzXPPanel.GetCount: Integer;
begin
  Result := High(Items) + 1;
end;

{procedure TzXPPanel.CMDialogChar(var Message: TCMDialogChar);

function GetHotkey(const Text: string): string;
var
  I, L: Integer;
begin
  Result := '';
  I := 1;
  L := Length(Text);
  while I <= L do
  begin
    if Text[I] in LeadBytes then
      Inc(I)
    else if (Text[I] = '&') and
            (L - I >= 1) then
    begin
      Inc(I);
      if Text[I] <> '&' then
        Result := Text[I]; // keep going there may be another one
    end;
    Inc(I);
  end;
end;

  function IsAccel(VK: Word; const Str: string): Boolean;
  begin
    Result := CompareText(Char(VK), GetHotKey(Str)) = 0;
  end;

begin
  if Enabled and IsAccel(Message.CharCode, Caption) then
  begin
        if Height < FFullHeight then
          Height := FFullHeight
        else Height := FCaptRect.Top + FCaptRect.Bottom + 1;
        Message.Result := 1;
  end
  else Message.Result := 1;
end;}

procedure TzXPPanel.SetSelected(Value: TItemLabel);
begin
  if FSelected <> Value then begin
    if Assigned(FSelected) then
      FSelected.Selected := False;
    FSelected := Value;
    if Assigned(FSelected) then
      FSelected.Selected := True;
  end;
end;

procedure TzXPPanel.Expand;
begin
  if Enabled and (Height <> FFullHeight) then begin
    Height := FFullHeight;
    Parent.Realign;
    // Michal Mutl
    FMinimized:=False;
    if Assigned(FOSC) then
      FOSC(Self);
  end;
end;

procedure TzXPPanel.Collapse;
begin
  Height := FCaptRect.Top + FCaptRect.Bottom + 1;
  Parent.Realign;
  // Michal Mutl
  FMinimized:=True;
  if Assigned(FOSC) then
    FOSC(Self);
end;

procedure TzXPPanel.DrawSeparator(yPos: Integer);
begin
  if (yPos < FCaptRect.Bottom) or (yPos > ClientRect.Bottom - 1) or (Height <> FFullHeight) then Exit;
  with Canvas, FCaptRect do begin
    Pen.Color := clWhite;
    MoveTo(Left, yPos);
    LineTo(Right, yPos);
  end;
end;

procedure TzXPPanel.BeginUpdate;
begin
  Inc(FUpdate);
end;

procedure TzXPPanel.EndUpdate;
begin
  if FUpdate > 0 then Dec(FUpdate);
  if FUpdate = 0 then RedrawItems;
end;

procedure TzXPPanel.SetMinimized(const Value: Boolean);  // Michal Mutl
begin
  if FMinimized<>Value then begin
    if Value then
      Collapse
    else
      Expand;
  end;
end;

procedure TzXPPanel.SetBS(const Value: Byte);  // Michal Mutl
begin
  FBS := Value;
  with FCaptRect do begin
    Left := FBS;
    Top := FBS;
    Bottom := 25;
  end;
  Invalidate;
end;

procedure TzXPPanel.SetGradientFromColor(const Value: TColor); // Michal Mutl
begin
  if FGradientFromColor <> Value then begin
    FGradientFromColor := Value;
    Repaint;
  end;
end;


procedure Register;
begin
  RegisterComponents('zPage', [TzXPPanel, TItemLabel]);
end;

{initialization
  Popuplist.Free;
  PopupList:= TExPopupList.Create;
  FTimer := TSimpleTimer.Create;
  FTimer.Interval := 100;
  FTimer.AutoDisable := false;
  FTimerClass := TTimerClass.Create;
  FTimer.OnTimer := FTimerClass.OnTimerProc;
  FTimer.Enabled := false;
  FOpeningNow := false;
//  ExtendedPopUp := false;
  FPopUpMenu := nil;
//  SetPopUpMenu(nil);

finalization
  FTimerClass.Free;
  FTimer.Free;}

end.
